#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>

#define checkError(expr,userMsg) \
    do {\
        if (!(expr)) {\
            perror(userMsg); \
            exit(EXIT_FAILURE); \
        } \
    } while (0)

#define BUFFER_SIZE (8096)

// odstampati sadrzaj fajla od pozicije a do pozicije b
// ./a.out filePath a b
int main(int argc, char** argv) {

    checkError(argc == 4, "args");

    int a = strtol(argv[2], NULL, 10);
    int b = strtol(argv[3], NULL, 10);

    

    int fd = open(argv[1], O_RDONLY);
    checkError(fd != -1, "open");

    checkError(lseek(fd, a, SEEK_SET) != (off_t)-1, "lseek");

    // male vrednosti a i b
    // char* buffer = malloc((b - a + 1)*sizeof(char));
    // checkError(buffer != NULL, "buffer");

    // int readBytes = read(fd, buffer, b-a+1);
    // checkError(readBytes != -1, "read");

    // readBytes = write(STDOUT_FILENO, buffer, readBytes);
    // checkError(readBytes != -1, "write");

    // free(buffer);

    /// velike vrednosti a i b
    char buffer[BUFFER_SIZE];
    int preostaloBajtova = b - a + 1;

    //while (1) {
    while (preostaloBajtova > 0) {

        int readBytes = read(fd, buffer, 
            preostaloBajtova < BUFFER_SIZE ? preostaloBajtova : BUFFER_SIZE);
        checkError(readBytes != -1, "read");

        preostaloBajtova -= readBytes;
        checkError(write(STDOUT_FILENO, buffer, readBytes) != -1, "write");

        // if (preostaloBajtova == 0)
        //     break;
    }

    close(fd);
    

    exit(EXIT_SUCCESS);
}