#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>

#define checkError(expr,userMsg) \
    do {\
        if (!(expr)) {\
            perror(userMsg); \
            exit(EXIT_FAILURE); \
        } \
    } while (0)

#define BUFFER_SIZE (8096)

// ./a.out src dest
int main(int argc, char** argv) {

    checkError(argc == 3, "args");

    int srcFd = open(argv[1], O_RDONLY);
    checkError(srcFd != -1, "open src");

    struct stat fInfo;
    checkError(stat(argv[1], &fInfo) != -1, "stat");

    int destFd = open(argv[2], O_WRONLY | O_CREAT | O_TRUNC, fInfo.st_mode);
    checkError(destFd != -1, "open dest");

    char buffer[BUFFER_SIZE];
    int bytesRead = 0;
    while ((bytesRead = read(srcFd, buffer, BUFFER_SIZE)) > 0) {

        checkError(write(destFd, buffer, bytesRead) != -1, "write");
    }

    checkError(bytesRead != -1, "read");

    close(srcFd);
    close(destFd);

    exit(EXIT_SUCCESS);
}