#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>

#define checkError(expr,userMsg) \
    do {\
        if (!(expr)) {\
            perror(userMsg); \
            exit(EXIT_FAILURE); \
        } \
    } while (0)

// ./a.out fileName rezim pravaPristupa
int main(int argc, char** argv) {

    checkError(argc == 4, "args");

    int flags = 0;
    switch (argv[2][0]) {
        case 'r':
            flags |= argv[2][1] == '+' ? O_RDWR : O_RDONLY;
            break;
        case 'w':
            flags |= argv[2][1] == '+' ? O_RDWR : O_WRONLY;
            flags |= O_CREAT;
            flags |= O_TRUNC;
            break;
        case 'a':
            flags |= argv[2][1] == '+' ? O_RDWR : O_WRONLY;
            flags |= O_CREAT;
            flags |= O_APPEND;
            break;
        default:
            checkError(0, "rezim");
    }

    mode_t pravaPristupa = strtol(argv[3], NULL, 8);

    int fd = open(argv[1], flags, pravaPristupa);
    checkError(fd != -1, "open");

    close(fd);

    exit(EXIT_SUCCESS);
}