#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>

#include <stdio.h>
#include <stdlib.h>

#define checkError(expr,userMsg) \
    do {\
        if (!(expr)) {\
            perror(userMsg); \
            exit(EXIT_FAILURE); \
        } \
    } while (0)

#define BUFFER_SIZE (8096)

// ./a.out filePath
int main(int argc, char** argv) {

    checkError(argc == 2, "args");

    int fd = open(argv[1], O_RDONLY);
    checkError(fd != -1, "open");

    off_t numberOfBytes = lseek(fd, 0, SEEK_END);
    checkError(numberOfBytes != (off_t)-1, "lseek");

    close(fd);

    printf("No of bytes: %d\n", (int)numberOfBytes);

    exit(EXIT_SUCCESS);
}